package java.time.chrono;

import java.time.temporal.ChronoField;
import java.time.format.DateTimeFormatterBuilder;
import java.util.Locale;
import java.time.format.TextStyle;
import java.time.DateTimeException;

public enum MinguoEra implements Era
{
    BEFORE_ROC, 
    ROC;
    
    public static MinguoEra of(int i) {
        switch (i) {
            case 0: {
                return MinguoEra.BEFORE_ROC;
            }
            case 1: {
                return MinguoEra.ROC;
            }
            default: {
                throw new DateTimeException("Invalid era: " + i);
            }
        }
    }
    
    @Override
    public int getValue() {
        return this.ordinal();
    }
    
    @Override
    public String getDisplayName(TextStyle textStyle, Locale locale) {
        return new DateTimeFormatterBuilder().appendText(ChronoField.ERA, textStyle).toFormatter(locale).withChronology(MinguoChronology.INSTANCE).format((this == MinguoEra.ROC) ? MinguoDate.of(1, 1, 1) : MinguoDate.of(0, 1, 1));
    }
}
